import {
    getConfig,
    checkResponseForError,
} from "./util";

import {
    fetchWithAuth,
    login,
} from "./auth";

export {
  onTagTextUpdate,
  onTagInputChanged,
} from "./tag";

export {
  addItemByTag,
  addItemByScan,
  addItemImage,
} from "./checkin";

export {
  listItemsByTag,
  listItemsByScan,
  //listItemsBySearch,
  onSearchInputUpdate,
  onSearchInputChanged,
} from "./checkout";

export {
  startScanningItem,
  stopScanningItem,
} from "./scanner";


/*
 * Checkout items
 */
/*

/*
 * More Helpers
 */
export async function loadStorages(selectedStorage) {
  console.log("Retrieving storages");
  var config = await getConfig();
  var response = await fetchWithAuth(config.backend_url + "/storages");
  if(await checkResponseForError(response, "Failed to load storages.")) {
    var storages = await response.json();
    var select = document.querySelector("#storage_select");
    console.log("Got storages");
    for (var i in storages) {
      var option = document.createElement("option");
      option.textContent = storages[i].name;
      option.value = storages[i].name;
      select.appendChild(option);
      if (selectedStorage == storages[i].name) {
        select.value = selectedStorage;
      }
    }
  }
}

export async function onPageLoad(doloadStorages) {
  await getConfig();
  let pw = window.location.hash.substring(1);
  await login(pw);
  if(doloadStorages) {
    loadStorages(document.location.search.substring(1));
  }
}
