import {
    Html5QrcodeScanner,
    Html5QrcodeScannerState,
    Html5QrcodeSupportedFormats
} from "html5-qrcode";

var scanner = new Html5QrcodeScanner("reader",{
  fps: 10,
  qrbox: { width: 250, height: 250 },
  showTorchButtonIfSupported: true,
  formatsToSupport: [ Html5QrcodeSupportedFormats.QR_CODE ], //there are many other types of codes on the labels we do not want
  rememberLastUsedCamera: true,
});

async function handleQrError(msg, err){ // eslint-disable-line no-unused-vars
  // if(err.type == 2 /*Not found*/ || err.errorMessage.includes("error = NotFoundException")) {
  //   return;
  // }
  // alert("Qrcode Error: " + msg + " (" + err + ")");
  // console.log("Qrcode Error: ", msg, err);

  // Sadly we can currently not reliably differentiate between a serious QR-Code Error and the "error",
  // that no QR code can be found.
  // Seems to be device-dependent,
  return;
}

export function debounceScanner() {
  if(scanner.getState() != Html5QrcodeScannerState.SCANNING) {
    return;
  }
  scanner.pause(false);
  setTimeout(function() {if(scanner.getState() == Html5QrcodeScannerState.PAUSED){scanner.resume();}}, 1000);
}

export async function startScanningItem(scannerCallback) {
  console.log("Starting scanner", scannerCallback, event);
  scanner.render(scannerCallback, handleQrError);
  document.getElementById("startScan").style.display = "none";
  document.getElementById("stopScan").style.display = "inline-block";
}

export async function stopScanningItem() {
  console.log("Stopping scanner");
  scanner.clear();
  document.getElementById("startScan").style.display = "inline-block";
  document.getElementById("stopScan").style.display = "none";
}

