var currentlyAddingItemByTag = new Map();

export async function onTagTextUpdate(callback) {
  // A character was typed
  var element = event.target;
  switch(event.target.value.length) {
    case 0:
      element.setCustomValidity("");
      element.classList.remove("is-invalid");
      break;
    case 8:
      tagEntered(event.target, callback);
      break;
    default:
      element.setCustomValidity("Code must be 8 chars long.");
      element.classList.add("is-invalid");
  }
}

export async function onTagInputChanged(callback) {
  // Element lost focus or user pressed enter
  console.log("changed tag", callback, event);
  if(event.target.value.length == 8) {
    tagEntered(event.target, callback);
  } else {
    event.target.reportValidity();
  }
}

export async function tagEntered(element , callback) {
  console.log("Tag Entered", tag);
  let tag = element.value;
  if(currentlyAddingItemByTag.has(tag)) {
    return;
  }
  currentlyAddingItemByTag.set(tag, "");
  let succ = await callback(tag);
  if(succ) {
    element.classList.remove("is-invalid");
    element.value = "";
    element.setCustomValidity("");
  } else {
    element.setCustomValidity("Unknown item");
    element.classList.add("is-invalid");
  }
  element.reportValidity();
  currentlyAddingItemByTag.delete(tag);
}
